# Unbuntu 20.04 encrypt ZFS install
you may read this first :  

* [ZFS focus on Ubuntu 20.04 LTS: what’s new?](https://didrocks.fr/2020/05/21/zfs-focus-on-ubuntu-20.04-lts-whats-new/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys general presentation](https://didrocks.fr/2020/05/26/zfs-focus-on-ubuntu-20.04-lts-zsys-general-presentation/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys sate management](https://didrocks.fr/2020/05/28/zfs-focus-on-ubuntu-20.04-lts-zsys-general-principle-on-state-management/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys commands for state management](https://didrocks.fr/2020/06/02/zfs-focus-on-ubuntu-20.04-lts-zsys-commands-for-state-management/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys state collection](https://didrocks.fr/2020/06/04/zfs-focus-on-ubuntu-20.04-lts-zsys-state-collection/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys for system administrators](https://didrocks.fr/2020/06/09/zfs-focus-on-ubuntu-20.04-lts-zsys-for-system-administrators/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys partition layout](https://didrocks.fr/2020/06/11/zfs-focus-on-ubuntu-20.04-lts-zsys-partition-layout/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys dataset layout](https://didrocks.fr/2020/06/16/zfs-focus-on-ubuntu-20.04-lts-zsys-dataset-layout/)
* [ZFS focus on Ubuntu 20.04 LTS: ZSys properties on ZFS datasets](https://didrocks.fr/2020/06/19/zfs-focus-on-ubuntu-20.04-lts-zsys-properties-on-zfs-datasets/)

Here we are going to install Ubuntu 20.04 in **almost** full zfs updating **zsys-setup** to permit **zfs encryption**.  Read above articles to understand why 2 differerent pools.

## initial boot and ssh
Boot the Ubuntu 20.04 Desktop installer/live CD.  
Click the “Try Ubuntu” button.  
launch a terminal.   

set a passwd to root to permit remote ssh

~~~
$ sudo su
## passwd
New password :
Retype new passord :
passwd: password updated successfully
~~~

Install ssh to simplfy configuration edit.

~~~
## apt install ssh
~~~

Edit **/etc/ssh/sshd_config** to **Enable PermitRootLogin** change *prohibit-password* to *yes* like bellow.

~~~{.shell}
#PermitRootLogin prohibit-password
PermitRootLogin yes
~~~

~~~
service ssh restart
~~~

find yout IP with : *ip a*  

then connect remotely with : *ssh*

## update zsys-setup to enable zfs encyption on rpool

bpool remain unencrypt.

Search for “zpool create”, and make sure you have found the create command that has “rpool” on the last line.
Before the “zpool create” insert: echo MYPASSWORD |
Before the last line of the command insert these lines:

~~~{.cpp}
-O recordsize=1M \
-O encryption=aes-256-gcm \
-O keylocation=prompt \
-O keyformat=passphrase \
~~~

## swap

you may be interrested if you are on a laptop in : [add right fit swap for laptop hibernation during ubuntu 20.04 full ZFS install](add-right-fit-swap-for-laptop-hibernation-during-ubuntu-20.04-full-ZFS-install)

## start installation

Run ubiquity to start the installer and install as normal, selecting “Use entire disk” and the option to use ZFS.